Index: /trunk/phpgwapi/setup/tables_update.inc.php
===================================================================
--- /trunk/phpgwapi/setup/tables_update.inc.php	(revision 7223)
+++ /trunk/phpgwapi/setup/tables_update.inc.php	(revision 7516)
@@ -170,5 +170,5 @@
 	}
 
-    $test[] = '2.4.1';
+    	$test[] = '2.4.1';
 	function phpgwapi_upgrade2_4_1()
 	{
@@ -176,3 +176,10 @@
 		return $GLOBALS['setup_info']['phpgwapi']['currentver'];
 	}
+        $test[] = '2.4.2';
+        function phpgwapi_upgrade2_4_2()
+        {
+                $GLOBALS['setup_info']['phpgwapi']['currentver'] = '2.5.0';
+                return $GLOBALS['setup_info']['phpgwapi']['currentver'];
+        }
+
 ?>
Index: /trunk/news_admin/setup/tables_update.inc.php
===================================================================
--- /trunk/news_admin/setup/tables_update.inc.php	(revision 7223)
+++ /trunk/news_admin/setup/tables_update.inc.php	(revision 7516)
@@ -80,9 +80,16 @@
 	}
 
-    $test[] = '2.4.1';
-    function news_admin_upgrade2_4_1()
-    {
-        $GLOBALS['setup_info']['news_admin']['currentver'] = '2.4.2';
-        return $GLOBALS['setup_info']['news_admin']['currentver'];
-    }
+    	$test[] = '2.4.1';
+    	function news_admin_upgrade2_4_1()
+    	{
+        	$GLOBALS['setup_info']['news_admin']['currentver'] = '2.4.2';
+        	return $GLOBALS['setup_info']['news_admin']['currentver'];
+    	}
+	$test[] = '2.4.2';
+    	function news_admin_upgrade2_4_2()
+    	{
+        	$GLOBALS['setup_info']['news_admin']['currentver'] = '2.5.0';
+        	return $GLOBALS['setup_info']['news_admin']['currentver'];
+    	}
+
 ?>
Index: /trunk/news_admin/setup/setup.inc.php
===================================================================
--- /trunk/news_admin/setup/setup.inc.php	(revision 7223)
+++ /trunk/news_admin/setup/setup.inc.php	(revision 7516)
@@ -14,5 +14,5 @@
 	$setup_info['news_admin']['name']      = 'news_admin';
 	$setup_info['news_admin']['title']     = 'News Admin';
-	$setup_info['news_admin']['version']   = '2.4.2';
+	$setup_info['news_admin']['version']   = '2.5.0';
 	$setup_info['news_admin']['app_order'] = 16;
 	$setup_info['news_admin']['enable']    = 1;
@@ -31,5 +31,5 @@
 	$setup_info['news_admin']['depends'][] = array(
 		 'appname' => 'phpgwapi',
-		 'versions' => Array('2.4.2')
+		 'versions' => Array('2.5.0')
 	);
 
Index: /trunk/reports/setup/setup.inc.php
===================================================================
--- /trunk/reports/setup/setup.inc.php	(revision 7223)
+++ /trunk/reports/setup/setup.inc.php	(revision 7516)
@@ -13,5 +13,5 @@
 	$setup_info['reports']['title']     	= 'Expresso Reports';
 	/* Ao incrementar versão, não esquecer de declarar função do tables_update.inc.php*/
-	$setup_info['reports']['version']   	= '2.4.2';
+	$setup_info['reports']['version']   	= '2.5.0';
 	$setup_info['reports']['app_order']	= 17;
 	$setup_info['reports']['tables']    = '';
@@ -41,5 +41,5 @@
 	$setup_info['reports']['depends'][] = array(
 		'appname' => 'phpgwapi',
-		'versions' => Array('2.4.2')
+		'versions' => Array('2.5.0')
 	);
 ?>
Index: /trunk/mobile/setup/setup.inc.php
===================================================================
--- /trunk/mobile/setup/setup.inc.php	(revision 7223)
+++ /trunk/mobile/setup/setup.inc.php	(revision 7516)
@@ -14,5 +14,5 @@
 	$setup_info['mobile']['name']      = 'mobile';
 	$setup_info['mobile']['title']     = 'Expresso Mini';
-	$setup_info['mobile']['version']   = '2.4.2';
+	$setup_info['mobile']['version']   = '2.5.0';
 	$setup_info['mobile']['app_order'] = 4;
 	$setup_info['mobile']['enable']    = 2;
@@ -39,5 +39,5 @@
 	$setup_info['mobile']['depends'][] = array(
 		'appname' => 'phpgwapi',
-		'versions' => Array('2.4.2')
+		'versions' => Array('2.5.0')
 	);
 ?>
Index: /trunk/filemanager/setup/setup.inc.php
===================================================================
--- /trunk/filemanager/setup/setup.inc.php	(revision 7223)
+++ /trunk/filemanager/setup/setup.inc.php	(revision 7516)
@@ -14,5 +14,5 @@
 	$setup_info['filemanager']['name']    = 'filemanager';
 	$setup_info['filemanager']['title']   = 'Filemanager';
-	$setup_info['filemanager']['version'] = '2.4.2';
+	$setup_info['filemanager']['version'] = '2.5.0';
 	$setup_info['filemanager']['app_order'] = 6;
 	$setup_info['filemanager']['enable']  = 1;
@@ -48,5 +48,5 @@
 	(
 		 'appname' => 'phpgwapi',
-		 'versions' => array('2.4.2')
+		 'versions' => array('2.5.0')
 	);
 ?>
Index: /trunk/expressoAdmin1_2/setup/tables_update.inc.php
===================================================================
--- /trunk/expressoAdmin1_2/setup/tables_update.inc.php	(revision 7223)
+++ /trunk/expressoAdmin1_2/setup/tables_update.inc.php	(revision 7516)
@@ -332,5 +332,5 @@
 	}
 
-    $test[] = '2.4.1';
+    	$test[] = '2.4.1';
 	function expressoAdmin1_2_upgrade2_4_1()
 	{
@@ -338,3 +338,9 @@
 		return $GLOBALS['setup_info']['expressoAdmin1_2']['currentver'];
 	}
+	$test[] = '2.4.2';
+        function expressoAdmin1_2_upgrade2_4_2()
+        {
+                $GLOBALS['setup_info']['expressoAdmin1_2']['currentver'] = '2.5.0';
+                return $GLOBALS['setup_info']['expressoAdmin1_2']['currentver'];
+        }
 ?>
Index: /trunk/expressoAdmin1_2/setup/setup.inc.php
===================================================================
--- /trunk/expressoAdmin1_2/setup/setup.inc.php	(revision 7223)
+++ /trunk/expressoAdmin1_2/setup/setup.inc.php	(revision 7516)
@@ -13,5 +13,5 @@
 	$setup_info['expressoAdmin1_2']['title']     	= 'Expresso Admin';
 	/* Ao incrementar versão, não esquecer de declarar função do tables_update.inc.php*/
-	$setup_info['expressoAdmin1_2']['version']   	= '2.4.2';
+	$setup_info['expressoAdmin1_2']['version']   	= '2.5.0';
 	$setup_info['expressoAdmin1_2']['app_order']	= 1;
 	$setup_info['expressoAdmin1_2']['tables'][]		= 'phpgw_expressoadmin';
@@ -37,5 +37,5 @@
 	$setup_info['expressoAdmin1_2']['depends'][] = array(
 		'appname' => 'phpgwapi',
-		'versions' => Array('2.4.2')
+		'versions' => Array('2.5.0')
 	);
 ?>
Index: /trunk/listAdmin/setup/setup.inc.php
===================================================================
--- /trunk/listAdmin/setup/setup.inc.php	(revision 7223)
+++ /trunk/listAdmin/setup/setup.inc.php	(revision 7516)
@@ -9,5 +9,5 @@
 	$setup_info['listAdmin']['name'] = 'listAdmin';
 	$setup_info['listAdmin']['title'] = 'Mailman Admin';
-	$setup_info['listAdmin']['version'] = '2.4.2';
+	$setup_info['listAdmin']['version'] = '2.5.0';
 	$setup_info['listAdmin']['app_order'] = 10;
 	$setup_info['listAdmin']['enable'] = 1;
@@ -30,5 +30,5 @@
 	$setup_info['listAdmin']['depends'][] = array(
 		'appname' => 'phpgwapi',
-		'versions' => Array('2.0','2.1','2.2','2.4', '2.4.2')
+		'versions' => Array('2.0','2.1','2.2','2.4', '2.5.0')
 	);
 ?>
Index: /trunk/admin/setup/setup.inc.php
===================================================================
--- /trunk/admin/setup/setup.inc.php	(revision 7223)
+++ /trunk/admin/setup/setup.inc.php	(revision 7516)
@@ -13,5 +13,5 @@
 	$setup_info['admin']['name']      = 'admin';
 	$setup_info['admin']['title']      = 'Admin';
-	$setup_info['admin']['version']   = '2.4.2';
+	$setup_info['admin']['version']   = '2.5.0';
 	$setup_info['admin']['app_order'] = 1;
 	$setup_info['admin']['tables']    = '';
@@ -48,5 +48,5 @@
 	$setup_info['admin']['depends'][] = array(
 		'appname' => 'phpgwapi',
-		'versions' => Array('2.4.2')
+		'versions' => Array('2.5.0')
 	);
 ?>
Index: /trunk/jabberit_messenger/setup/setup.inc.php
===================================================================
--- /trunk/jabberit_messenger/setup/setup.inc.php	(revision 7223)
+++ /trunk/jabberit_messenger/setup/setup.inc.php	(revision 7516)
@@ -8,5 +8,5 @@
 	$setup_info['jabberit_messenger']['name']      	= 'jabberit_messenger';
 	$setup_info['jabberit_messenger']['title']     	= 'Expresso Messenger';
-	$setup_info['jabberit_messenger']['version']   	= '2.4.2';
+	$setup_info['jabberit_messenger']['version']   	= '2.5.0';
 	$setup_info['jabberit_messenger']['app_order'] 	= 9;
 	$setup_info['jabberit_messenger']['enable']    	= 1;
@@ -27,5 +27,5 @@
 	$setup_info['jabberit_messenger']['depends'][] = array(
 		'appname' => 'phpgwapi',
-		'versions' => Array('2.4.2')
+		'versions' => Array('2.5.0')
 	);
 ?>
Index: /trunk/contactcenter/setup/tables_update.inc.php
===================================================================
--- /trunk/contactcenter/setup/tables_update.inc.php	(revision 7223)
+++ /trunk/contactcenter/setup/tables_update.inc.php	(revision 7516)
@@ -94,8 +94,13 @@
  	}
 
-    $test[] = '2.4.1';
-    function contactcenter_upgrade2_4_1() {
-        $GLOBALS['setup_info']['contactcenter']['currentver'] = '2.4.2';
-        return $GLOBALS['setup_info']['contactcenter']['currentver'];
-    }
+    	$test[] = '2.4.1';
+    	function contactcenter_upgrade2_4_1() {
+        	$GLOBALS['setup_info']['contactcenter']['currentver'] = '2.4.2';
+        	return $GLOBALS['setup_info']['contactcenter']['currentver'];
+    	}
+	$test[] = '2.4.2';
+    	function contactcenter_upgrade2_4_2() {
+        	$GLOBALS['setup_info']['contactcenter']['currentver'] = '2.5.0';
+        	return $GLOBALS['setup_info']['contactcenter']['currentver'];
+    	}
 ?>
Index: /trunk/contactcenter/setup/setup.inc.php
===================================================================
--- /trunk/contactcenter/setup/setup.inc.php	(revision 7223)
+++ /trunk/contactcenter/setup/setup.inc.php	(revision 7516)
@@ -17,5 +17,5 @@
 	$setup_info['contactcenter']['name']      = 'contactcenter';
 	$setup_info['contactcenter']['title']     = 'ContactCenter';
-	$setup_info['contactcenter']['version']   = '2.4.2';
+	$setup_info['contactcenter']['version']   = '2.5.0';
 	$setup_info['contactcenter']['app_order'] = 4;
 	$setup_info['contactcenter']['enable']    = 1;
@@ -77,5 +77,5 @@
 	$setup_info['contactcenter']['depends'][] = array(
 		'appname' => 'phpgwapi',
-		'versions' => Array('2.4.2')
+		'versions' => Array('2.5.0')
 	);
 ?>
Index: /trunk/emailadmin/setup/tables_update.inc.php
===================================================================
--- /trunk/emailadmin/setup/tables_update.inc.php	(revision 7223)
+++ /trunk/emailadmin/setup/tables_update.inc.php	(revision 7516)
@@ -142,3 +142,10 @@
       return $GLOBALS['setup_info']['emailadmin']['currentver'];
    }
+	$test[] = '2.4.2';
+	function emailadmin_upgrade2_4_2()
+	{
+      		$GLOBALS['setup_info']['emailadmin']['currentver'] = '2.5.0';
+      		return $GLOBALS['setup_info']['emailadmin']['currentver'];
+	}
+
 ?>
Index: /trunk/emailadmin/setup/setup.inc.php
===================================================================
--- /trunk/emailadmin/setup/setup.inc.php	(revision 7223)
+++ /trunk/emailadmin/setup/setup.inc.php	(revision 7516)
@@ -14,5 +14,5 @@
 	$setup_info['emailadmin']['name']      = 'emailadmin';
 	$setup_info['emailadmin']['title']     = 'EMailAdmin';
-	$setup_info['emailadmin']['version']   = '2.4.2';
+	$setup_info['emailadmin']['version']   = '2.5.0';
 	$setup_info['emailadmin']['app_order'] = 10;
 	$setup_info['emailadmin']['enable']    = 2;
@@ -40,5 +40,5 @@
 	$setup_info['emailadmin']['depends'][] = array(
 		'appname'  => 'phpgwapi',
-		'versions' => Array('2.4.2')
+		'versions' => Array('2.5.0')
 	);
 
Index: /trunk/preferences/setup/setup.inc.php
===================================================================
--- /trunk/preferences/setup/setup.inc.php	(revision 7223)
+++ /trunk/preferences/setup/setup.inc.php	(revision 7516)
@@ -13,5 +13,5 @@
 	$setup_info['preferences']['name']      = 'preferences';
 	$setup_info['preferences']['title']     = 'Preferences';
-	$setup_info['preferences']['version']   = '2.4.2';
+	$setup_info['preferences']['version']   = '2.5.0';
 	$setup_info['preferences']['app_order'] = 1;
 	$setup_info['preferences']['tables']    = '';
@@ -28,5 +28,5 @@
 	$setup_info['preferences']['depends'][] = array(
 		'appname' => 'phpgwapi',
-		'versions' => Array('2.4.2')
+		'versions' => Array('2.5.0')
 	);
 ?>
Index: /trunk/calendar/setup/tables_update.inc.php
===================================================================
--- /trunk/calendar/setup/tables_update.inc.php	(revision 7223)
+++ /trunk/calendar/setup/tables_update.inc.php	(revision 7516)
@@ -148,3 +148,11 @@
         return $GLOBALS['setup_info']['calendar']['currentver'];
     }
+	$test[] = '2.4.2';
+    	function calendar_upgrade2_4_2()
+    	{
+        	$GLOBALS['setup_info']['calendar']['currentver'] = '2.5.0';
+        	return $GLOBALS['setup_info']['calendar']['currentver'];
+    	}
+
+
 ?>
Index: /trunk/calendar/setup/setup.inc.php
===================================================================
--- /trunk/calendar/setup/setup.inc.php	(revision 7223)
+++ /trunk/calendar/setup/setup.inc.php	(revision 7516)
@@ -12,5 +12,5 @@
 
 	$setup_info['calendar']['name']    = 'calendar';
-	$setup_info['calendar']['version'] = '2.4.2';
+	$setup_info['calendar']['version'] = '2.5.0';
 	$setup_info['calendar']['app_order'] = 3;
 	$setup_info['calendar']['enable']  = 1;
@@ -52,4 +52,4 @@
 	$setup_info['calendar']['depends'][] = array(
 		 'appname' => 'phpgwapi',
-		 'versions' => Array('2.4.2')
+		 'versions' => Array('2.5.0')
 	);
Index: /trunk/workflow/setup/tables_update.inc.php
===================================================================
--- /trunk/workflow/setup/tables_update.inc.php	(revision 7223)
+++ /trunk/workflow/setup/tables_update.inc.php	(revision 7516)
@@ -360,4 +360,11 @@
         return $GLOBALS['setup_info']['workflow']['currentver'];
     }
+	$test[] = '2.4.2';
+    	function workflow_upgrade2_4_2()
+    	{
+        	$GLOBALS['setup_info']['workflow']['currentver'] = '2.5.0';
+        	return $GLOBALS['setup_info']['workflow']['currentver'];
+    	}
+
 
 ?>
Index: /trunk/workflow/setup/setup.inc.php
===================================================================
--- /trunk/workflow/setup/setup.inc.php	(revision 7223)
+++ /trunk/workflow/setup/setup.inc.php	(revision 7516)
@@ -13,5 +13,5 @@
 	$setup_info['workflow']['name']			= 'workflow';
 	$setup_info['workflow']['title']		= 'Workflow Management';
-	$setup_info['workflow']['version']		= '2.4.2';
+	$setup_info['workflow']['version']		= '2.5.0';
 	$setup_info['workflow']['app_order']	= 10;
 	$setup_info['workflow']['enable']		= 1;
@@ -59,9 +59,9 @@
 	$setup_info['workflow']['depends'][] = array(
 		'appname' => 'phpgwapi',
-		'versions' => Array('1.2', '2.0', '2.2', '2.4')
+		'versions' => Array('1.2', '2.0', '2.2', '2.4', '2.5')
 	);
 	$setup_info['workflow']['depends'][] = array(
 		'appname' => 'preferences',
-		'versions' => Array('0.9.13.002', '2.0', '2.2', '2.4.2')
+		'versions' => Array('0.9.13.002', '2.0', '2.2', '2.5.0')
 	);
 ?>
Index: /trunk/expressoMail1_2/setup/tables_update.inc.php
===================================================================
--- /trunk/expressoMail1_2/setup/tables_update.inc.php	(revision 7223)
+++ /trunk/expressoMail1_2/setup/tables_update.inc.php	(revision 7516)
@@ -329,3 +329,9 @@
     }
 
+	$test[] = '2.4.8.2';
+    	function expressoMail1_2_upgrade2_4_8_2() {
+        	$GLOBALS['setup_info']['expressoMail1_2']['currentver'] = '2.5.0';
+        	return $GLOBALS['setup_info']['expressoMail1_2']['currentver'];
+    	}
+
 ?>
Index: /trunk/expressoMail1_2/setup/setup.inc.php
===================================================================
--- /trunk/expressoMail1_2/setup/setup.inc.php	(revision 7223)
+++ /trunk/expressoMail1_2/setup/setup.inc.php	(revision 7516)
@@ -13,5 +13,5 @@
 $setup_info['expressoMail1_2']['name'] = 'expressoMail1_2';
 $setup_info['expressoMail1_2']['title'] = 'Expresso Mail';
-$setup_info['expressoMail1_2']['version'] = '2.4.8.2';
+$setup_info['expressoMail1_2']['version'] = '2.5.0';
 $setup_info['expressoMail1_2']['app_order'] = 2;
 $setup_info['expressoMail1_2']['tables'][] = 'phpgw_certificados';
@@ -46,5 +46,5 @@
 $setup_info['expressoMail1_2']['depends'][] = array(
     'appname' => 'phpgwapi',
-    'versions' => Array('2.4.2')
+    'versions' => Array('2.5.0')
 );
 